if [ ! -e "$1" ]; then
  echo File not found $1!
  exit
fi
T=$1

ARCH="-mabi=32 -mips32 -mno-shared -mno-llsc -mno-dsp -mno-fused-madd -mno-check-zero-division -mno-mt -mno-mips3d -mno-mdmx -mno-paired-single -mno-dspr2"

OPTS="-funswitch-loops -foptimize-sibling-calls -fforward-propagate -fmerge-constants -fmerge-all-constants -fmodulo-sched -fmodulo-sched-allow-regmoves -fthread-jumps -fsplit-wide-types -fcse-follow-jumps -fcse-skip-blocks -frerun-cse-after-loop -fgcse -fgcse-lm -fgcse-sm -fgcse-las -fgcse-after-reload -funsafe-loop-optimizations -fcrossjumping -fauto-inc-dec -fdce -fdse -fif-conversion -fif-conversion2 -fdelete-null-pointer-checks -fexpensive-optimizations -fregmove -fsee -fschedule-insns -fcaller-saves -ftree-reassoc -ftree-pre -ftree-fre -ftree-copy-prop -ftree-salias -fipa-pure-const -fipa-reference -fipa-pta -fipa-cp -fipa-matrix-reorg -ftree-sink -ftree-ccp -ftree-store-ccp -ftree-dce -ftree-dominator-opts -ftree-dse -ftree-ch -ftree-loop-optimize -ftree-loop-optimize -ftree-loop-im -ftree-loop-ivcanon -fivopts -ftree-sra -ftree-copyrename -ftree-ter -ftree-vectorize -ftree-vect-loop-version -ftree-vrp -ftracer -fvariable-expansion-in-unroller -fpredictive-commoning -fpeephole -fpeephole2 -freorder-blocks -freorder-blocks-and-partition -freorder-functions -fstrict-aliasing -fstrict-overflow -falign-functions -falign-labels -falign-loops -falign-jumps -fcprop-registers -fmove-loop-invariants -fguess-branch-probability -fdefer-pop -fomit-frame-pointer -funit-at-a-time  -finline-functions -finline-small-functions"
OPTS2="-fdelayed-branch -fschedule-insns2 -funroll-loops -funroll-all-loops -fbranch-target-load-optimize -fbranch-target-load-optimize2 -O3 -fwhole-program "
OPTS2="-Os -fwhole-program -fno-delayed-branch"

mkdir tmp &> /dev/null
cd tmp

if [ "$2" == "" ]; then
  OPTS3=""
else
  OPTS3="$2"
fi
(cat <<EOT
SECTIONS {
  outputa 0x4:
    {
    init.o (.text)
    }
  outputb 0x12:
    {
    ${T}.o (.text)
    }
  .sdata 0x1000:
    {
    *(.sdata)
    }
  .bss :
    AT( 0x1000 + SIZEOF(.sdata))
    {
    }
}
EOT
) > script

(cat <<EOT
extern int main(void);

void __start() {
  main();
}
EOT
) > init.c

mips-gcc init.c -c -Os -s

mips-gcc ../${T} -c -o ${T}.o ${ARCH} ${OPTS} ${OPTS2} ${OPTS3} || exit
mips-ld -Tscript ${T}.o -o ${T}-opti -O -x -s -nostdlib -static -e __start --gc-sections || exit

mips-objdump -d ${T}.o -z |sed '1,6 d' > elfo
mips-objcopy -O binary -R .reginfo ${T}-opti ${T}-opti || exit
mips-objdump -D -m mips -b binary -EB --adjust-vma 4 ${T}-opti | sed '1,6 d' > rawo

#mips-gcc ../${T} -c ${ARCH} ${OPTS} ${OPTS3} || exit
mips-gcc ../${T} -c ${ARCH} || exit
mips-ld -Tscript ${T}.o -o ${T} -O -x -s -nostdlib -static -e __start --gc-sections || exit
#mips-linux-gnu-ld -Tscript ${T}.o -o ${T} -nostdlib -static -e __start || exit
objdump -s -j .sdata ${T}.o

mips-objdump -d ${T}.o -z |sed '1,6 d' > elf
mips-objcopy -O binary -R .reginfo ${T} ${T} || exit
mips-objdump -D -m mips -b binary -EB --adjust-vma 4 ${T} | sed '1,6 d' > raw

echo "  ---  ---  ---  ---  ---  ---" > separator

cat raw separator rawo|sed 's/:\t/: /g'|sed 's/\t\([a-z]\{2\}\)\t/\t\1     \t/g'|sed 's/\t\([a-z]\{3\}\)\t/\t\1    \t/g'|sed 's/\t\([a-z]\{1\}\)\t/\t\1      \t/g' > rawb
cat elf separator elfo|sed 's/:\t/: /g'|sed 's/\t\([a-z]\{2\}\)\t/\t\1     \t/g'|sed 's/\t\([a-z]\{3\}\)\t/\t\1    \t/g'|sed 's/\t\([a-z]\{1\}\)\t/\t\1      \t/g' > elfb

cat rawb|grep j.*$ -o|cut -f2|cut -dx -f2|tr "\n" "|"|sed 's/|/\\|/g' > l
cat rawb|sed "s/^\( *\($(cat l)ra\):.*\)/\n\1/g" > raw

pr -Ttm -W 190 -e4 -S"|" raw elfb ../${T}
